<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_stats_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanStatsPractice".
 *
 * Columns in table "scan_stats_practice" available as properties of the model,
 * followed by relations of table "scan_stats_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_input_practice_id
 * @property integer $op_score
 * @property string $reviews_average
 * @property integer $listing_accuracy
 * @property integer $missing_listings
 * @property integer $total_reviews
 * @property integer $google_reviews
 * @property integer $yelp_reviews
 * @property integer $profile_completion_score
 * @property string $profile_completion_missing_data
 * @property string $missing_listing_names
 * @property string $reviews_grade
 *
 * @property ScanRequestPractice $scanInputPractice
 */
abstract class BaseScanStatsPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_stats_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanStatsPractice|ScanStatsPractices', $n);
    }

    public static function representingColumn()
    {
        return 'reviews_average';
    }

    public function rules()
    {
        return array(
            array('scan_input_practice_id', 'required'),
            array('id, scan_input_practice_id, op_score, listing_accuracy, missing_listings, total_reviews, google_reviews, yelp_reviews, profile_completion_score', 'numerical', 'integerOnly' => true),
            array('reviews_average', 'length', 'max' => 3),
            array('reviews_grade', 'length', 'max' => 5),
            array('profile_completion_missing_data, missing_listing_names', 'safe'),
            array('op_score, reviews_average, listing_accuracy, missing_listings, total_reviews, google_reviews, yelp_reviews, profile_completion_score, profile_completion_missing_data, missing_listing_names, reviews_grade', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_input_practice_id, op_score, reviews_average, listing_accuracy, missing_listings, total_reviews, google_reviews, yelp_reviews, profile_completion_score, profile_completion_missing_data, missing_listing_names, reviews_grade', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanInputPractice' => array(self::BELONGS_TO, 'ScanRequestPractice', 'scan_input_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_input_practice_id' => null,
            'op_score' => Yii::t('app', 'Op Score'),
            'reviews_average' => Yii::t('app', 'Reviews Average'),
            'listing_accuracy' => Yii::t('app', 'Listing Accuracy'),
            'missing_listings' => Yii::t('app', 'Missing Listings'),
            'total_reviews' => Yii::t('app', 'Total Reviews'),
            'google_reviews' => Yii::t('app', 'Google Reviews'),
            'yelp_reviews' => Yii::t('app', 'Yelp Reviews'),
            'profile_completion_score' => Yii::t('app', 'Profile Completion Score'),
            'profile_completion_missing_data' => Yii::t('app', 'Profile Completion Missing Data'),
            'missing_listing_names' => Yii::t('app', 'Missing Listing Names'),
            'reviews_grade' => Yii::t('app', 'Reviews Grade'),
            'scanInputPractice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_input_practice_id', $this->scan_input_practice_id);
        $criteria->compare('op_score', $this->op_score);
        $criteria->compare('reviews_average', $this->reviews_average, true);
        $criteria->compare('listing_accuracy', $this->listing_accuracy);
        $criteria->compare('missing_listings', $this->missing_listings);
        $criteria->compare('total_reviews', $this->total_reviews);
        $criteria->compare('google_reviews', $this->google_reviews);
        $criteria->compare('yelp_reviews', $this->yelp_reviews);
        $criteria->compare('profile_completion_score', $this->profile_completion_score);
        $criteria->compare('profile_completion_missing_data', $this->profile_completion_missing_data, true);
        $criteria->compare('missing_listing_names', $this->missing_listing_names, true);
        $criteria->compare('reviews_grade', $this->reviews_grade, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
